
#include <stdio.h>
#include <stdbool.h>
#include "myint.h"
#include "aki80.h"

void initCTC3(void)
{
	outp(CTC3, 0x03);	//_~[R}h
	outp(CTC3, 0x07);	//^C}[h 1/16
	outp(CTC3, 0x2);	//TimeConstant, 0x49600bps, 0x219200bps
}

void initSIOA(void)
{
	outp(SIOA_CMD, SIO_CMD_Null | 0);		//WR0I
	outp(SIOA_CMD, SIO_CMD_ChRst | 0);		//Zbg
	outp(SIOA_CMD, SIO_CMD_RstExtInt | 4);	//RR0ZbgAWR4I
	outp(SIOA_CMD, 0x44);					//x16Clock, 1Stop, NoParity
	outp(SIOA_CMD, SIO_CMD_Null | 3);		//WR3I
	outp(SIOA_CMD, 0xc1);					//MWbits, 
	outp(SIOA_CMD, SIO_CMD_Null | 5);		//WR5I
	outp(SIOA_CMD, 0x68);					//MWbits, 
}

int SIOA_getc(void)
{
	volatile uchar status=inp(SIOA_CMD);
	volatile uchar error;
	if((status & 0x01)==0)		return EOF;	//Mf[^Ȃ
	
	outp(SIOA_CMD, SIO_CMD_Null | 1);		//RR1I
	error=inp(SIOA_CMD);
	//G[?
	if(error &= 0x70)		return -(int)error;
	else					return inp(SIOA_DATA);
}

void SIOA_putc(char c)
{
	volatile uchar status;
	do{
		status=inp(SIOA_CMD);
	}while((status & 0x04)==0);
	outp(SIOA_DATA, c);
}

void SIOA_puts(char *s)
{
	while(*s!='\0')
		SIOA_putc(*s++);
	SIOA_putc('\n');
	SIOA_putc('\r');
}

uchar SIOA_transmitNow(void)
{
	volatile uchar status2;
	outp(SIOA_CMD, SIO_CMD_Null | 1);		//WR1I
	status2=inp(SIOA_CMD);
	if(status2 & 0x01)		return 0;
	else					return 1;
}


/*	^XN֘Å֐錾
 */
extern bool init_task(uchar no,void (*func)(void));
extern uint switch_sp(uint sp);
extern void task_switch(void);		//misc.xas

int gCount;		//^XN߂̃JE^

void task1(void)
{
	for(;;){
		xprintf(SIOA_putc, "task1 %d\n\r", gCount++);
		task_switch();
	}
}

void task2(void)
{
	static int i;
	for(;;){
		xprintf(SIOA_putc, "task2 %d\n\r", gCount++);
		task_switch();
	}
}


void main(void)
{
	uchar c;
	initCTC3();
	initSIOA();
	
	init_task(1, task1);
	init_task(2, task2);
	for(c = 0; c < 3; c++){
		xprintf(SIOA_putc, "main %d\n\r", gCount++);
		task_switch();
	}
	while(SIOA_transmitNow())              
		;
	#asm
		jp 0h	;j^vO
	#endasm
}


#pragma int_reti_n
void defaultInterrupt(void)
{
}
#pragma noint_reti_n

#asm
	global __rst8
	__rst8	EQU _defaultInterrupt
	global __rst10
	__rst10	EQU _defaultInterrupt
	global __rst18
	__rst18 EQU _defaultInterrupt
	global __rst20
	__rst20 EQU _defaultInterrupt
	global __rst28
	__rst28 EQU _defaultInterrupt
	global __rst30
	__rst30 EQU _defaultInterrupt
	global __rst38
	__rst38 EQU _defaultInterrupt
#endasm

#pragma int_retn_n
void _NMI(void)
{
}
#pragma noint_retn_n
